# Storage Transfer v1 API - Namespace Google.Cloud.StorageTransfer.V1 (2.10.0)

<button class="button button-with-icon cloud-select-dropdown__button " aria-haspopup="true">Version latest</button>

- [2.10.0 (latest)](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1)
- [2.9.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.9.0/Google.Cloud.StorageTransfer.V1)
- [2.8.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.8.0/Google.Cloud.StorageTransfer.V1)
- [2.7.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.7.0/Google.Cloud.StorageTransfer.V1)
- [2.6.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.6.0/Google.Cloud.StorageTransfer.V1)
- [2.5.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.5.0/Google.Cloud.StorageTransfer.V1)
- [2.4.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.4.0/Google.Cloud.StorageTransfer.V1)
- [2.3.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.3.0/Google.Cloud.StorageTransfer.V1)
- [2.2.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.2.0/Google.Cloud.StorageTransfer.V1)
- [2.1.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.1.0/Google.Cloud.StorageTransfer.V1)
- [2.0.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/2.0.0/Google.Cloud.StorageTransfer.V1)
- [1.2.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/1.2.0/Google.Cloud.StorageTransfer.V1)
- [1.1.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/1.1.0/Google.Cloud.StorageTransfer.V1)
- [1.0.0](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/1.0.0/Google.Cloud.StorageTransfer.V1)

## Classes

### [AgentPool](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AgentPool)

Represents an agent pool.

### [AgentPool.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AgentPool.Types)

Container for nested types declared in the AgentPool message type.

### [AgentPool.Types.BandwidthLimit](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AgentPool.Types.BandwidthLimit)

Specifies a bandwidth limit for an agent pool.

### [AwsAccessKey](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AwsAccessKey)

AWS access key (see
[AWS Security
Credentials](https://docs.aws.amazon.com/general/latest/gr/aws-security-credentials.html)).

For information on our data retention policy for user credentials, see
[User credentials](https://docs.cloud.google.com/storage-transfer/docs/data-retention#user-credentials).

### [AwsS3CompatibleData](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AwsS3CompatibleData)

An AwsS3CompatibleData resource.

### [AwsS3Data](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AwsS3Data)

An AwsS3Data resource can be a data source, but not a data sink.
In an AwsS3Data resource, an object's name is the S3 object's key name.

### [AzureBlobStorageData](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AzureBlobStorageData)

An AzureBlobStorageData resource can be a data source, but not a data sink.
An AzureBlobStorageData resource represents one Azure container. The storage
account determines the [Azure
endpoint](https://docs.microsoft.com/en-us/azure/storage/common/storage-create-storage-account#storage-account-endpoints).
In an AzureBlobStorageData resource, a blobs's name is the [Azure Blob
Storage blob's key
name](https://docs.microsoft.com/en-us/rest/api/storageservices/naming-and-referencing-containers--blobs--and-metadata#blob-names).

### [AzureBlobStorageData.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AzureBlobStorageData.Types)

Container for nested types declared in the AzureBlobStorageData message type.

### [AzureBlobStorageData.Types.FederatedIdentityConfig](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AzureBlobStorageData.Types.FederatedIdentityConfig)

The identity of an Azure application through which Storage Transfer Service
can authenticate requests using Azure workload identity federation.

Storage Transfer Service can issue requests to Azure Storage through
registered Azure applications, eliminating the need to pass credentials to
Storage Transfer Service directly.

To configure federated identity, see
[Configure access to Microsoft Azure
Storage](https://cloud.google.com/storage-transfer/docs/source-microsoft-azure#option_3_authenticate_using_federated_identity).

### [AzureCredentials](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AzureCredentials)

Azure credentials

For information on our data retention policy for user credentials, see
[User credentials](https://docs.cloud.google.com/storage-transfer/docs/data-retention#user-credentials).

### [CreateAgentPoolRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.CreateAgentPoolRequest)

Specifies the request passed to CreateAgentPool.

### [CreateTransferJobRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.CreateTransferJobRequest)

Request passed to CreateTransferJob.

### [DeleteAgentPoolRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.DeleteAgentPoolRequest)

Specifies the request passed to DeleteAgentPool.

### [DeleteTransferJobRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.DeleteTransferJobRequest)

Request passed to DeleteTransferJob.

### [ErrorLogEntry](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ErrorLogEntry)

An entry describing an error that has occurred.

### [ErrorSummary](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ErrorSummary)

A summary of errors by error code, plus a count and sample error log
entries.

### [EventStream](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.EventStream)

Specifies the Event-driven transfer options. Event-driven transfers listen to
an event stream to transfer updated files.

### [GcsData](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.GcsData)

In a GcsData resource, an object's name is the Cloud Storage object's
name and its "last modification time" refers to the object's `updated`
property of Cloud Storage objects, which changes when the content or the
metadata of the object is updated.

### [GetAgentPoolRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.GetAgentPoolRequest)

Specifies the request passed to GetAgentPool.

### [GetGoogleServiceAccountRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.GetGoogleServiceAccountRequest)

Request passed to GetGoogleServiceAccount.

### [GetTransferJobRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.GetTransferJobRequest)

Request passed to GetTransferJob.

### [GoogleServiceAccount](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.GoogleServiceAccount)

Google service account

### [HdfsData](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.HdfsData)

An HdfsData resource specifies a path within an HDFS entity (e.g. a cluster).
All cluster-specific settings, such as namenodes and ports, are configured on
the transfer agents servicing requests, so HdfsData only contains the root
path to the data in our transfer.

### [HttpData](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.HttpData)

An HttpData resource specifies a list of objects on the web to be
transferred over HTTP. The information of the objects to be transferred is
contained in a file referenced by a URL. The first line in the file must be
`"TsvHttpData-1.0"`, which specifies the format of the file. Subsequent
lines specify the information of the list of objects, one object per list
entry. Each entry has the following tab-delimited fields:

- **HTTP URL** --- The location of the object.

- **Length** --- The size of the object in bytes.

- **MD5** --- The base64-encoded MD5 hash of the object.

  For an example of a valid TSV file, see
  [Transferring data from
  URLs](https://cloud.google.com/storage-transfer/docs/create-url-list).

  When transferring data based on a URL list, keep the following in mind:

<!-- -->

- When an object located at `http(s)://hostname:port/<URL-path>` is
  transferred to a data sink, the name of the object at the data sink is
  `<hostname>/<URL-path>`.

- If the specified size of an object does not match the actual size of the
  object fetched, the object is not transferred.

- If the specified MD5 does not match the MD5 computed from the transferred
  bytes, the object transfer fails.

- Ensure that each URL you specify is publicly accessible. For
  example, in Cloud Storage you can
  [share an object publicly](https://docs.cloud.google.com/storage/docs/cloud-console#_sharingdata) and get a link to it.

- Storage Transfer Service obeys `robots.txt` rules and requires the source
  HTTP server to support `Range` requests and to return a `Content-Length`
  header in each response.

- \[ObjectConditions\]\[google.storagetransfer.v1.ObjectConditions\] have no
  effect when filtering objects to transfer.

### [ListAgentPoolsRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ListAgentPoolsRequest)

The request passed to ListAgentPools.

### [ListAgentPoolsResponse](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ListAgentPoolsResponse)

Response from ListAgentPools.

### [ListTransferJobsRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ListTransferJobsRequest)

`projectId`, `jobNames`, and `jobStatuses` are query parameters that can
be specified when listing transfer jobs.

### [ListTransferJobsResponse](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ListTransferJobsResponse)

Response from ListTransferJobs.

### [LoggingConfig](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.LoggingConfig)

Specifies the logging behavior for transfer operations.

Logs can be sent to Cloud Logging for all transfer types. See
[Read transfer
logs](https://cloud.google.com/storage-transfer/docs/read-transfer-logs) for
details.

### [LoggingConfig.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.LoggingConfig.Types)

Container for nested types declared in the LoggingConfig message type.

### [MetadataOptions](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions)

Specifies the metadata options for running a transfer.

### [MetadataOptions.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types)

Container for nested types declared in the MetadataOptions message type.

### [NotificationConfig](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.NotificationConfig)

Specification to configure notifications published to Pub/Sub.
Notifications are published to the customer-provided topic using the
following `PubsubMessage.attributes`:

- `"eventType"`: one of the \[EventType\]\[google.storagetransfer.v1.NotificationConfig.EventType\] values
- `"payloadFormat"`: one of the \[PayloadFormat\]\[google.storagetransfer.v1.NotificationConfig.PayloadFormat\] values
- `"projectId"`: the \[project_id\]\[google.storagetransfer.v1.TransferOperation.project_id\] of the `TransferOperation`
- `"transferJobName"`: the \[transfer_job_name\]\[google.storagetransfer.v1.TransferOperation.transfer_job_name\] of the `TransferOperation`
- `"transferOperationName"`: the \[name\]\[google.storagetransfer.v1.TransferOperation.name\] of the `TransferOperation`

The `PubsubMessage.data` contains a
\[TransferOperation\]\[google.storagetransfer.v1.TransferOperation\] resource
formatted according to the specified `PayloadFormat`.

### [NotificationConfig.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.NotificationConfig.Types)

Container for nested types declared in the NotificationConfig message type.

### [ObjectConditions](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ObjectConditions)

Conditions that determine which objects are transferred. Applies only
to Cloud Data Sources such as S3, Azure, and Cloud Storage.

The "last modification time" refers to the time of the
last change to the object's content or metadata --- specifically, this is
the `updated` property of Cloud Storage objects, the `LastModified` field
of S3 objects, and the `Last-Modified` header of Azure blobs.

For S3 objects, the `LastModified` value is the time the object begins
uploading. If the object meets your "last modification time" criteria,
but has not finished uploading, the object is not transferred. See
[Transfer from Amazon S3 to Cloud
Storage](https://cloud.google.com/storage-transfer/docs/create-transfers/agentless/s3#transfer_options)
for more information.

Transfers with a \[PosixFilesystem\]\[google.storagetransfer.v1.PosixFilesystem\]
source or destination don't support `ObjectConditions`.

### [PauseTransferOperationRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.PauseTransferOperationRequest)

Request passed to PauseTransferOperation.

### [PosixFilesystem](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.PosixFilesystem)

A POSIX filesystem resource.

### [ReplicationSpec](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ReplicationSpec)

Specifies the configuration for a cross-bucket replication job. Cross-bucket
replication copies new or updated objects from a source Cloud Storage bucket
to a destination Cloud Storage bucket. Existing objects in the source bucket
are not copied by a new cross-bucket replication job.

### [ResumeTransferOperationRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ResumeTransferOperationRequest)

Request passed to ResumeTransferOperation.

### [RunTransferJobRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.RunTransferJobRequest)

Request passed to RunTransferJob.

### [S3CompatibleMetadata](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.S3CompatibleMetadata)

S3CompatibleMetadata contains the metadata fields that apply to the basic
types of S3-compatible data providers.

### [S3CompatibleMetadata.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.S3CompatibleMetadata.Types)

Container for nested types declared in the S3CompatibleMetadata message type.

### [Schedule](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.Schedule)

Transfers can be scheduled to recur or to run just once.

### [StorageTransferService](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferService)

Storage Transfer Service and its protos.
Transfers data between between Google Cloud Storage buckets or from a data
source external to Google to a Cloud Storage bucket.

### [StorageTransferService.StorageTransferServiceBase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferService.StorageTransferServiceBase)

Base class for server-side implementations of StorageTransferService

### [StorageTransferService.StorageTransferServiceClient](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferService.StorageTransferServiceClient)

Client for StorageTransferService

### [StorageTransferServiceClient](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferServiceClient)

StorageTransferService client wrapper, for convenient use.

### [StorageTransferServiceClientBuilder](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferServiceClientBuilder)

Builder class for [StorageTransferServiceClient](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferServiceClient) to provide simple configuration of credentials,
endpoint etc.

### [StorageTransferServiceClientImpl](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferServiceClientImpl)

StorageTransferService client wrapper implementation, for convenient use.

### [StorageTransferServiceSettings](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferServiceSettings)

Settings for [StorageTransferServiceClient](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.StorageTransferServiceClient) instances.

### [TransferCounters](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferCounters)

A collection of counters that report the progress of a transfer operation.

### [TransferJob](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferJob)

This resource represents the configuration of a transfer job that runs
periodically.

### [TransferJob.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferJob.Types)

Container for nested types declared in the TransferJob message type.

### [TransferManifest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferManifest)

Specifies where the manifest is located.

### [TransferOperation](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferOperation)

A description of the execution of a transfer.

### [TransferOperation.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferOperation.Types)

Container for nested types declared in the TransferOperation message type.

### [TransferOptions](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferOptions)

TransferOptions define the actions to be performed on objects in a transfer.

### [TransferOptions.Types](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferOptions.Types)

Container for nested types declared in the TransferOptions message type.

### [TransferSpec](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferSpec)

Configuration for running a transfer.

### [UpdateAgentPoolRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.UpdateAgentPoolRequest)

Specifies the request passed to UpdateAgentPool.

### [UpdateTransferJobRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.UpdateTransferJobRequest)

Request passed to UpdateTransferJob.

### [agentPoolsName](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.agentPoolsName)

Resource name for the `agentPools` resource.

## Enums

### [AgentPool.Types.State](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AgentPool.Types.State)

The state of an AgentPool.

### [AwsS3CompatibleData.DataProviderOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AwsS3CompatibleData.DataProviderOneofCase)

Enum of possible cases for the "data_provider" oneof.

### [AwsS3Data.PrivateNetworkOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.AwsS3Data.PrivateNetworkOneofCase)

Enum of possible cases for the "private_network" oneof.

### [LoggingConfig.Types.LoggableAction](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.LoggingConfig.Types.LoggableAction)

Loggable actions.

### [LoggingConfig.Types.LoggableActionState](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.LoggingConfig.Types.LoggableActionState)

Loggable action states.

### [MetadataOptions.Types.Acl](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.Acl)

Options for handling Cloud Storage object ACLs.

### [MetadataOptions.Types.GID](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.GID)

Options for handling file GID attribute.

### [MetadataOptions.Types.KmsKey](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.KmsKey)

Options for handling the KmsKey setting for Google Cloud Storage objects.

### [MetadataOptions.Types.Mode](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.Mode)

Options for handling file mode attribute.

### [MetadataOptions.Types.StorageClass](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.StorageClass)

Options for handling Google Cloud Storage object storage class.

### [MetadataOptions.Types.Symlink](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.Symlink)

Whether symlinks should be skipped or preserved during a transfer job.

### [MetadataOptions.Types.TemporaryHold](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.TemporaryHold)

Options for handling temporary holds for Google Cloud Storage objects.

### [MetadataOptions.Types.TimeCreated](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.TimeCreated)

Options for handling `timeCreated` metadata for Google Cloud Storage
objects.

### [MetadataOptions.Types.UID](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.MetadataOptions.Types.UID)

Options for handling file UID attribute.

### [NotificationConfig.Types.EventType](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.NotificationConfig.Types.EventType)

Enum for specifying event types for which notifications are to be
published.

Additional event types may be added in the future. Clients should either
safely ignore unrecognized event types or explicitly specify which event
types they are prepared to accept.

### [NotificationConfig.Types.PayloadFormat](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.NotificationConfig.Types.PayloadFormat)

Enum for specifying the format of a notification message's payload.

### [ReplicationSpec.DataSinkOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ReplicationSpec.DataSinkOneofCase)

Enum of possible cases for the "data_sink" oneof.

### [ReplicationSpec.DataSourceOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.ReplicationSpec.DataSourceOneofCase)

Enum of possible cases for the "data_source" oneof.

### [S3CompatibleMetadata.Types.AuthMethod](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.S3CompatibleMetadata.Types.AuthMethod)

The authentication and authorization method used by the storage service.

### [S3CompatibleMetadata.Types.ListApi](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.S3CompatibleMetadata.Types.ListApi)

The Listing API to use for discovering objects.

### [S3CompatibleMetadata.Types.NetworkProtocol](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.S3CompatibleMetadata.Types.NetworkProtocol)

The agent network protocol to access the storage service.

### [S3CompatibleMetadata.Types.RequestModel](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.S3CompatibleMetadata.Types.RequestModel)

The request model of the API.

### [TransferJob.Types.Status](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferJob.Types.Status)

The status of the transfer job.

### [TransferOperation.Types.Status](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferOperation.Types.Status)

The status of a TransferOperation.

### [TransferOptions.Types.OverwriteWhen](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferOptions.Types.OverwriteWhen)

Specifies when to overwrite an object in the sink when an object with
matching name is found in the source.

### [TransferSpec.DataSinkOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferSpec.DataSinkOneofCase)

Enum of possible cases for the "data_sink" oneof.

### [TransferSpec.DataSourceOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferSpec.DataSourceOneofCase)

Enum of possible cases for the "data_source" oneof.

### [TransferSpec.IntermediateDataLocationOneofCase](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.TransferSpec.IntermediateDataLocationOneofCase)

Enum of possible cases for the "intermediate_data_location" oneof.

### [agentPoolsName.ResourceNameType](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.agentPoolsName.ResourceNameType)

The possible contents of [agentPoolsName](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.StorageTransfer.V1/latest/Google.Cloud.StorageTransfer.V1.agentPoolsName).